﻿
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D


Module DirectX_Drawings

    Friend MediaPath As String
    Friend ExtraMediaPath As String

    Friend msh_Array(-1) As Mesh
    'Friend Textures(-1) As Texture
    Friend Materials(-1) As Material

    ' ------------------------------------------------- Sky params Default without INI
    Friend DX_LightDirection As Single = 0
    Friend DX_LightHeight As Single = 60
    Friend DX_SkyType As Int32 = 1



    ' ===============================================================================================
    '   MESHES AND TEXTURES
    ' ===============================================================================================

    Friend Structure MeshStruct
        Dim Scene As Mesh
        Dim Terrain As Mesh
        Dim Terrain2 As Mesh
        Dim TerrainFlat As Mesh
        Dim Box2 As Mesh
        Dim Barrel As Mesh
        Dim Box As Mesh
        Dim Cylinder As Mesh
        Dim Sphere As Mesh
    End Structure
    Friend Meshes As MeshStruct


    Friend Structure ExtendedMeshStruct
        Dim mtx As Matrix
        Dim msh As Mesh
        Dim mat() As ExtendedMaterial
        'Dim tex() As Texture
        Dim bbmin As Vector3
        Dim bbmax As Vector3
    End Structure
    Friend Structure ExtendedMeshes
        Dim TerrainHill As ExtendedMeshStruct
        Dim Castle As ExtendedMeshStruct
        Dim Eiffel As ExtendedMeshStruct
        Dim CastleTerrain As ExtendedMeshStruct
        Dim CarBody As ExtendedMeshStruct
        Dim CarWheel As ExtendedMeshStruct
        Dim FluidContainer As ExtendedMeshStruct
    End Structure
    Friend ExMeshes As ExtendedMeshes



    Friend Structure TexturesStruct
        Dim DefaultGrey As Texture
        Dim OldWood As Texture
        Dim Island As Texture
        Dim Gold As Texture
        Dim grassdark As Texture
        Dim oldmetal As Texture
        Dim redrust2 As Texture
        Dim ground As Texture
        Dim plateox2 As Texture
        Dim Panels_Wood_H As Texture
        Dim iron_flo As Texture
        Dim Car3_Body As Texture
        Dim Cloth1 As Texture
        Dim Cloth2 As Texture
        Dim Cloth3 As Texture
        Dim Cloth4 As Texture
        Dim Rope1 As Texture
        Dim Rope2 As Texture
        Dim Rope3 As Texture
        Dim CastleTerracottaMud As Texture
        Dim CastleTerracotta As Texture
        Dim CastleTiles As Texture
        Dim CastleGold As Texture
        Dim CastleTerrain As Texture
        Dim Duck_spheric As Texture
        Dim Frog_spheric As Texture
        'Dim BarrelNew As Texture
    End Structure
    Friend Tex As TexturesStruct




    Friend Sub DX_LoadMeshAndTextures()
        MediaPath = System.Windows.Forms.Application.StartupPath & "\Media\"
        ExtraMediaPath = System.Windows.Forms.Application.StartupPath & "\ExtraMedia\"

        ' -------------------------------------------------------------------------- LOAD MESHES
        ReDim msh_Array(9)
        Meshes.Scene = LoadMesh("Scene.x")
        'Meshes(0) = LoadMesh("a3dtree.x")
        'Meshes(0) = LoadMesh("Church_bt.x")
        'Meshes(0) = LoadMesh("Fortino.x")

        Meshes.Terrain = LoadMesh("Terrain.x")
        Meshes.Terrain2 = LoadMesh("Island_L.x")
        Meshes.TerrainFlat = LoadMesh("TerrainFlat.x")

        Meshes.Box2 = LoadMesh("Box2.x")
        Meshes.Barrel = LoadMesh("Barrel.x")
        Meshes.Box = LoadMesh("Box.x")
        Meshes.Cylinder = LoadMesh("Cylinder.x")
        Meshes.Sphere = LoadMesh("Sphere.x")

        ' -------------------------------------------------------------------------- LOAD EXTENDED MESHES
        LoadExtendedMesh(ExMeshes.TerrainHill, "Terrain.x", Matrix.Identity)
        LoadExtendedMesh(ExMeshes.CarBody, "CarBody.x", Matrix.Identity)
        LoadExtendedMesh(ExMeshes.CarWheel, "CarWheel.x", Matrix.Identity)
        LoadExtendedMesh(ExMeshes.CastleTerrain, "Castle\CastleTerrain.x", Matrix.Identity)


        ' -------------------------------------------------------------------------- LOAD TEXTURES
        Tex.DefaultGrey = CreateDefaultTexture()
        Tex.OldWood = LoadTexture("Images\OldWood.jpg")
        Tex.Island = LoadTexture("Images\Isola.jpg")
        Tex.Gold = LoadTexture("Images\Gold.jpg")
        Tex.grassdark = LoadTexture("Images\grassdark.jpg")
        Tex.oldmetal = LoadTexture("Images\oldmetal.jpg")
        Tex.redrust2 = LoadTexture("Images\redrust2.jpg")
        Tex.ground = LoadTexture("Images\ground.jpg")
        Tex.plateox2 = LoadTexture("Images\plateox2.jpg")
        Tex.Panels_Wood_H = LoadTexture("Images\Panels_Wood_H.jpg")
        Tex.iron_flo = LoadTexture("Images\iron_flo.jpg")
        Tex.Car3_Body = LoadTexture("Images\Car3_Body.jpg")
        Tex.Cloth1 = LoadTexture("Images\Cloth1.jpg")
        Tex.Cloth2 = LoadTexture("Images\Cloth2.jpg")
        Tex.Cloth3 = LoadTexture("Images\Cloth3.jpg")
        Tex.Cloth4 = LoadTexture("Images\Cloth4.jpg")
        Tex.Rope1 = LoadTexture("Images\Rope1.jpg")
        Tex.Rope2 = LoadTexture("Images\Rope2.jpg")
        Tex.Rope3 = LoadTexture("Images\Rope3.jpg")
        Tex.Duck_spheric = LoadTexture("Xfiles\Duck_spheric.jpg")
        Tex.Frog_spheric = LoadTexture("Xfiles\Frog_spheric.jpg")
        'Tex.BarrelNew = LoadTexture("Xfiles\BarrelNew.jpg")

        Tex.CastleTerracottaMud = LoadTexture("Xfiles\Castle\castle_terracotta_mud_ramp.JPG")
        Tex.CastleTerracotta = LoadTexture("Xfiles\Castle\castle_terracotta.JPG")
        Tex.CastleTiles = LoadTexture("Xfiles\Castle\castle_tiles_1.JPG")
        Tex.CastleGold = LoadTexture("Xfiles\Castle\castle_gold.JPG")
        Tex.CastleTerrain = LoadTexture("Xfiles\Castle\castle_beige_blotchy.JPG")

        DX_LoadAmbientMap()
    End Sub




    Friend Function LoadTexture(ByVal FileName As String) As Texture
        Try
            'Return TextureLoader.FromFile(DX_Device, MediaPath & FileName)
            Return TextureLoader.FromFile(DX_Device, MediaPath & FileName, _
                                          0, 0, 0, 0, Format.Dxt1, Pool.Managed, Filter.Linear, Filter.Linear, 0)
        Catch
            Return Nothing
        End Try
    End Function



    Friend Function DX_LoadAmbientTexture(ByVal FileName As String) As Texture
        Try
            'Return TextureLoader.FromFile(DX_Device, MediaPath & "AmbientMaps\" & FileName)
            Return TextureLoader.FromFile(DX_Device, MediaPath & "AmbientMaps\" & FileName, _
                                           0, 0, 0, 0, Format.Unknown, Pool.Managed, Filter.Linear, Filter.Linear, 0)
        Catch
            Return Nothing
        End Try
    End Function

    Friend Sub DX_LoadAmbientMap()
        Dim FileName As String = ""
        Select Case DX_SkyType
            Case 0 : FileName = "Sunset II"
            Case 1 : FileName = "DXClouds"
        End Select
        If tex_AmbientPosX IsNot Nothing Then tex_AmbientPosX.Dispose()
        If tex_AmbientPosY IsNot Nothing Then tex_AmbientPosY.Dispose()
        If tex_AmbientPosZ IsNot Nothing Then tex_AmbientPosZ.Dispose()
        If tex_AmbientNegX IsNot Nothing Then tex_AmbientNegX.Dispose()
        If tex_AmbientNegY IsNot Nothing Then tex_AmbientNegY.Dispose()
        If tex_AmbientNegZ IsNot Nothing Then tex_AmbientNegZ.Dispose()

        tex_AmbientPosX = DX_LoadAmbientTexture(FileName & "_PosX.JPG")
        tex_AmbientPosY = DX_LoadAmbientTexture(FileName & "_PosY.JPG")
        tex_AmbientPosZ = DX_LoadAmbientTexture(FileName & "_PosZ.JPG")
        tex_AmbientNegX = DX_LoadAmbientTexture(FileName & "_NegX.JPG")
        tex_AmbientNegY = DX_LoadAmbientTexture(FileName & "_NegY.JPG")
        tex_AmbientNegZ = DX_LoadAmbientTexture(FileName & "_NegZ.JPG")
    End Sub

    Friend Sub DX_CalculateBoundingBoxForAllObjects()
        For i As Int32 = 0 To UBound(Objects_3D)
            With Objects_3D(i)
                DX_ComputeBoundingBoxFromMesh(.MeshX.msh, .MeshX.bbmin, .MeshX.bbmax)
            End With
        Next
    End Sub

    Friend Sub DX_SetMovingObjectsMeshIndex(ByVal quality As Boolean)
        DEBUG_HiQuality = quality
        For i As Int32 = 0 To UBound(Objects_3D)
            With Objects_3D(i)
                If .IsMovingObject Then
                    If DEBUG_HiQuality Then
                        If .ObjType = ObjTypes.BOX Then .MeshX.msh = Meshes.Box2
                        If .ObjType = ObjTypes.CYLINDER Then .MeshX.msh = Meshes.Barrel
                    Else
                        If .ObjType = ObjTypes.BOX Then .MeshX.msh = Meshes.Box
                        If .ObjType = ObjTypes.CYLINDER Then .MeshX.msh = Meshes.Cylinder
                    End If
                    If .ObjType = ObjTypes.SPHERE Then .MeshX.msh = Meshes.Sphere
                End If
            End With
        Next
    End Sub

    Friend Sub DX_ToggleQuality()
        DX_SetMovingObjectsMeshIndex(Not DEBUG_HiQuality)
    End Sub



    ' ===============================================================================================
    '   LIGHTS AND MATERIALS
    ' ===============================================================================================
    Private LightTypePoint As Boolean = False

    Friend Sub DX_InitLights()
        With DX_Device.Lights(0)
            If LightTypePoint Then
                .Type = LightType.Point
                .Attenuation0 = 0.7
                .Attenuation1 = 0
                .Attenuation2 = 0
                .Falloff = 1
                .Range = 30000
                .AmbientColor = New ColorValue(0.7, 0.6, 0.5, 0) '(0.5, 0.4, 0.3, 0)
                .DiffuseColor = New ColorValue(0.7, 0.7, 0.7, 0)
                .SpecularColor = New ColorValue(0.5, 0.5, 0.5, 0)
            Else
                .Type = LightType.Directional
                .AmbientColor = New ColorValue(0.75, 0.6, 0.45, 0) '(1.0, 0.8, 0.6, 0) '(0.5, 0.4, 0.3, 0)
                .DiffuseColor = New ColorValue(1.0, 1.0, 1.0, 0)
                .SpecularColor = New ColorValue(0.7, 0.7, 0.7, 0)
            End If
        End With
        With DX_Device.Lights(1)
            If LightTypePoint Then
                .Type = LightType.Point
                .Attenuation0 = 0.7
                .Attenuation1 = 0
                .Attenuation2 = 0
                .Falloff = 1
                .Range = 30000
                .AmbientColor = New ColorValue(0, 0, 0, 0)
                .DiffuseColor = New ColorValue(0.7, 0.7, 0.7, 0)
                .SpecularColor = New ColorValue(0.5, 0.5, 0.5, 0)
            Else
                .Type = LightType.Directional
                .AmbientColor = New ColorValue(0, 0, 0, 0)
                .DiffuseColor = New ColorValue(1.0, 1.0, 1.0, 0)
                .SpecularColor = New ColorValue(0.3, 0.3, 0.7, 0)
            End If
        End With

        DX_SetLightDirection()
    End Sub



    Friend Sub DX_SetLightDirection()

        ' --------------------------------------------------------- initial rotation
        Dim LightRotDegree As Single = DX_LightDirection - 45

        ' --------------------------------------------------------- back cubemap rotation
        Select Case DX_SkyType
            Case 0 : DX_BackMatRot = 97 - LightRotDegree
            Case 1 : DX_BackMatRot = 43 - LightRotDegree
        End Select

        ' --------------------------------------------------------- light 1 and 2 directions
        Dim LightDir1 As Vector3 = Vector3.Normalize(VEC3(0, 0, -1))
        Dim LightDir2 As Vector3 = LightDir1
        LightDir1 = Vector3.TransformNormal(LightDir1, Matrix.RotationX(DX_LightHeight * KRAD))
        LightDir1 = Vector3.TransformNormal(LightDir1, Matrix.RotationY(LightRotDegree * KRAD))

        LightDir2 = Vector3.TransformNormal(LightDir2, Matrix.RotationX((DX_LightHeight + 10) * KRAD))
        LightDir2 = Vector3.TransformNormal(LightDir2, Matrix.RotationY(LightRotDegree * KRAD))

        ' --------------------------------------------------------- light positions or light directions
        If LightTypePoint Then
            DX_Device.Lights(0).Position = LightDir1 * 8500
            DX_Device.Lights(1).Position = LightDir2 * 8500
        Else
            DX_Device.Lights(0).Direction = -LightDir1
            DX_Device.Lights(1).Direction = -LightDir2
        End If
        ' --------------------------------------------------------- "enable" used to update changes
        DX_Device.Lights(0).Enabled = True
        DX_Device.Lights(1).Enabled = True

        ' --------------------------------------------------------- set shadow light direction
        Shadow_LightDir = LightDir1
    End Sub


    Friend Function Material(Optional ByVal Ar As Single = 0.5, _
                              Optional ByVal Ag As Single = 0.5, _
                              Optional ByVal Ab As Single = 0.5, _
                              Optional ByVal Dr As Single = 0.5, _
                              Optional ByVal Dg As Single = 0.5, _
                              Optional ByVal Db As Single = 0.5, _
                              Optional ByVal Da As Single = 1, _
                              Optional ByVal Er As Single = 0, _
                              Optional ByVal Eg As Single = 0, _
                              Optional ByVal Eb As Single = 0, _
                              Optional ByVal Sr As Single = 0.2, _
                              Optional ByVal Sg As Single = 0.2, _
                              Optional ByVal Sb As Single = 0.2, _
                              Optional ByVal Sharp As Single = 17) As Material
        '
        Material.AmbientColor = New ColorValue(Ar, Ag, Ab, 1)
        Material.DiffuseColor = New ColorValue(Dr, Dg, Db, Da)
        Material.EmissiveColor = New ColorValue(Er, Eg, Eb, 1)
        Material.SpecularColor = New ColorValue(Sr, Sg, Sb, 1)
        Material.SpecularSharpness = Sharp
    End Function


    Friend Sub DX_InitMaterials()
        ReDim Materials(12)
        ' ------------------------------------------------------------ BUILDINGS
        Materials(0) = Material(0.5, 0.5, 0.5, 0.25, 0.2, 0.2, , , , , 0.15, 0.0, 0.0, 80)

        ' ------------------------------------------------------------ TERRAIN FLAT
        Materials(1) = Material(0.45, 0.25, 0.45, 0.35, 0.25, 0.35, , , , , 0.3, 0.15, 0.05, 6)

        ' ------------------------------------------------------------ BOXES METAL
        Materials(2) = Material(0.45, 0.45, 0.45, 1.5, 1.5, 1.5, , , , , 1.3, 0.5, 1.0, 23)

        ' ------------------------------------------------------------ BOXES WOOD
        Materials(3) = Material(1.0, 1.0, 1.0, 0.45, 0.3, 0.3, , , , , 0.22, 0.15, 0.15, 12)

        ' ------------------------------------------------------------ BARRELS
        Materials(4) = Material(0.45, 0.45, 0.6, 0.9, 0.9, 1.0, , , , , 0.5, 0.35, 0.8, 17)

        ' ------------------------------------------------------------ BARRELS
        Materials(5) = Material(0.45, 0.45, 0.6, 0.9, 0.9, 1.0, , , , , 0.45, 0.3, 0.75, 17)

        ' ------------------------------------------------------------ SPHERES
        Materials(6) = Material(1.3, 1.3, 1.3, 0.9, 0.9, 0.9, , , , , 0.3, 0.15, 0.45, 17)

        ' ------------------------------------------------------------ TERRAIN MESH
        Materials(7) = Material(0.5, 0.25, 0.4, 0.15, 0.12, 0.15, , , , , 0.15, 0.08, 0.0, 12)

        ' ------------------------------------------------------------ Cloth
        Materials(8) = Material(1.2, 1.2, 1.2, 2.8, 2.4, 1.0, , , , , 0.2, 0.1, 0.08, 17)

        ' ------------------------------------------------------------ Castle Tiles and Mountains
        Materials(9) = Material(0.4, 0.4, 0.4, 0.5, 0.5, 0.5, , , , , 0.2, 0.1, 0.0, 17)

        ' ------------------------------------------------------------ Castle Terrain
        Materials(10) = Material(0.2, 0.2, 0.2, 0.3, 0.3, 0.3, , , , , 0.2, 0.1, 0.0, 17)

        ' ------------------------------------------------------------ Car black parts
        Materials(11) = Material(0.1, 0.1, 0.1, 0.2, 0.2, 0.2, , , , , 0.05, 0.05, 0.0, 17)

        ' ------------------------------------------------------------ Eiffel
        Materials(12) = Material(0.2, 0.15, 0.1, 0.2, 0.15, 0.1, , , , , 0.2, 0.1, 0.05, 30)

    End Sub






    ' ===============================================================================================
    '   AMBIENT MAP
    ' ===============================================================================================

    Friend DX_BackMatRot As Single
    Private Const BackMatPos As Single = 9999
    Private Const ScreenAspect As Single = 1

    Friend Sub DX_RenderAmbientMap()

        With DX_Device
            ' ---------------------------------------------------------------------------------- 1
            'Dim m1 As Material
            ''m1.AmbientColor = New ColorValue(1.0, 0.9, 0.9)
            ''m1.DiffuseColor = New ColorValue(1.0, 0.8, 0.8)
            'm1.EmissiveColor = New ColorValue(0.7, 0.6, 0.65)
            '.Material = m1
            '.RenderState.Lighting = True
            '.TextureState(0).ColorOperation = TextureOperation.Modulate2X

            ' ---------------------------------------------------------------------------------- 2 OK
            .RenderState.AlphaBlendEnable = False
            .RenderState.Lighting = False
            .TextureState(0).ColorOperation = TextureOperation.SelectArg1
            .TextureState(0).ColorArgument1 = TextureArgument.TextureColor

            .SamplerState(0).MagFilter = TextureFilter.Anisotropic
            .SamplerState(0).MinFilter = TextureFilter.Anisotropic
            .SamplerState(0).MipFilter = TextureFilter.None

            .SamplerState(0).AddressU = TextureAddress.Clamp
            .SamplerState(0).AddressV = TextureAddress.Clamp
            .SamplerState(0).AddressW = TextureAddress.Wrap
        End With


        Dim mWorld As Matrix
        Dim mRotY As Matrix
        Dim mRotZ As Matrix
        Dim v(4) As CustomVertex.PositionNormalTextured
        Dim r As Single
        Dim ViewDir As Vector3
        Dim ViewUp As Vector3

        r = BackMatPos
        ' ------------------------
        v(0).X = -r
        v(0).Y = -r
        v(0).Z = r
        v(0).Tu = 0
        v(0).Tv = 1
        v(0).Nx = 0
        v(0).Ny = 0
        v(0).Nz = -1
        ' ------------------------
        v(1).X = -r
        v(1).Y = r
        v(1).Z = r
        v(1).Tu = 0
        v(1).Tv = 0
        v(1).Nx = 0
        v(1).Ny = 0
        v(1).Nz = -1
        ' ------------------------
        v(2).X = r
        v(2).Y = -r
        v(2).Z = r
        v(2).Tu = 1
        v(2).Tv = 1
        v(2).Nx = 0
        v(2).Ny = 0
        v(2).Nz = -1
        ' ------------------------
        v(3).X = r
        v(3).Y = r
        v(3).Z = r
        v(3).Tu = 1
        v(3).Tv = 0
        v(3).Nx = 0
        v(3).Ny = 0
        v(3).Nz = -1
        ' ------------------------------------------------------------------- view direction
        mRotY = Matrix.RotationY(DX_BackMatRot * KRAD)
        Dim mvi As Matrix = Matrix.Invert(mtx_CameraView)
        ViewDir = Vector3.TransformNormal(Matrix_GetVectorDir(mvi), mRotY)
        ViewUp = Vector3.TransformNormal(Matrix_GetVectorUp(mvi), mRotY)
        ' ------------------------------------------------------------------- 
        Dim m As Matrix
        m = Matrix.LookAtLH(VEC3(0, 0, 0), ViewDir, ViewUp)
        DX_Device.Transform.View = m
        '     ... qui si potrebbe usare da 50 fino a 80 ...   .. ma 0.05 e 999999 sono critici
        m = Matrix.PerspectiveFovLH(50 / Camera.Lens, ScreenAspect, 0.05, 999999)
        DX_Device.Transform.Projection = m
        ' ------------------------------------------------------------------- rotation matrix Y and Z
        mWorld = Matrix.Identity
        mRotY = Matrix.RotationAxis(VEC3(0, 1, 0), 90 * KRAD)
        mRotZ = Matrix.RotationAxis(VEC3(0, 0, 1), 90 * KRAD)
        ' ------------------------------------------------------------------- init
        DX_Device.RenderState.CullMode = Cull.CounterClockwise
        DX_Device.RenderState.DepthBias = 0
        DX_Device.RenderState.ZBufferWriteEnable = False
        DX_Device.VertexFormat = CustomVertex.PositionNormalTextured.Format
        ' ------------------------------------------------------------------- posz
        DX_Device.SetTexture(0, tex_AmbientPosZ)
        DX_Device.Transform.World = mWorld
        DX_Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        ' ------------------------------------------------------------------- posx
        DX_Device.SetTexture(0, tex_AmbientPosX)
        mWorld = Matrix.Multiply(mWorld, mRotY)
        DX_Device.Transform.World = mWorld
        DX_Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        ' ------------------------------------------------------------------- negz
        DX_Device.SetTexture(0, tex_AmbientNegZ)
        mWorld = Matrix.Multiply(mWorld, mRotY)
        DX_Device.Transform.World = mWorld
        DX_Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        ' ------------------------------------------------------------------- negx
        DX_Device.SetTexture(0, tex_AmbientNegX)
        mWorld = Matrix.Multiply(mWorld, mRotY)
        DX_Device.Transform.World = mWorld
        DX_Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        ' ------------------------------------------------------------------- negy
        DX_Device.SetTexture(0, tex_AmbientNegY)
        mWorld = Matrix.Multiply(mWorld, mRotZ)
        mWorld = Matrix.Multiply(mWorld, mRotY)
        DX_Device.Transform.World = mWorld
        DX_Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        ' ------------------------------------------------------------------- posy
        DX_Device.SetTexture(0, tex_AmbientPosY)
        mWorld = Matrix.Multiply(mWorld, mRotY)
        mWorld = Matrix.Multiply(mWorld, mRotY)
        mWorld = Matrix.Multiply(mWorld, mRotZ)
        mWorld = Matrix.Multiply(mWorld, mRotZ)
        DX_Device.Transform.World = mWorld
        DX_Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        ' -------------------------------------------------------------------
        'ResetVrMaterial(DX_Device)
    End Sub


    Public Sub DX8_RenderFrontQuad(ByVal tex As Texture, _
                                   Optional ByVal x As Single = 0, _
                                   Optional ByVal y As Single = 0, _
                                   Optional ByVal w As Single = 1, _
                                   Optional ByVal h As Single = 1)

        If tex Is Nothing Then Return

        x = x * 2 - 1
        y = y * 2 - 1
        w *= 2
        h *= 2

        Dim z As Single = 1 '0.1

        Dim v(4) As CustomVertex.PositionNormalTextured

        v(0).X = x      '-1
        v(0).Y = y      '-1
        v(0).Z = z
        v(0).Tu = 0
        v(0).Tv = 1

        v(1).X = x      '-1
        v(1).Y = y + h  '+1
        v(1).Z = z
        v(1).Tu = 0
        v(1).Tv = 0

        v(2).X = x + w  '+1
        v(2).Y = y      '-1
        v(2).Z = z
        v(2).Tu = 1
        v(2).Tv = 1

        v(3).X = x + w  '+1
        v(3).Y = y + h  '+1
        v(3).Z = z
        v(3).Tu = 1
        v(3).Tv = 0


        Dim mView As Matrix
        Dim mProj As Matrix


        If Form2.chk_Test2.Checked Then
            ' ------------------------------------------------------------------------ old ( to remove )
            mProj = Matrix.OrthoLH(1.995, 1.995, 0.01, 999)
            mView = Matrix.LookAtLH(VEC3(0, 0, 0), VEC3(0, 0, 1), VEC3(0, 1, 0))
        Else
            ' ------------------------------------------------------------------------ new ( ok )
            mProj = Matrix.OrthoLH(2.001, 2.002, 0.01, 999)
            mView = Matrix.LookAtLH(VEC3(0, 0, 0), VEC3(0.002, -0.002, 1), VEC3(0, 1, 0))
        End If

        DX_Device.SetTransform(TransformType.View, mView)
        DX_Device.SetTransform(TransformType.Projection, mProj)

        DX_Device.SetTransform(TransformType.World, Matrix.Identity)

        With DX_Device
            .RenderState.Lighting = False
            .RenderState.DepthBias = 0
            .RenderState.ZBufferWriteEnable = False
            .RenderState.ZBufferFunction = Compare.Always
            .RenderState.CullMode = Cull.CounterClockwise

            '.TextureState(0).ColorOperation = TextureOperation.Modulate

            If SHAD_HiQualityFilters Then
                .SamplerState(0).MagFilter = TextureFilter.Linear
                .SamplerState(0).MinFilter = TextureFilter.Linear
            Else
                .SamplerState(0).MagFilter = TextureFilter.Point
                .SamplerState(0).MinFilter = TextureFilter.Point
            End If

            '.SamplerState(0).AddressU = TextureAddress.Clamp
            '.SamplerState(0).AddressV = TextureAddress.Clamp
            '.SamplerState(0).AddressW = TextureAddress.Clamp


            .SetTexture(0, tex)

            .VertexFormat = CustomVertex.PositionNormalTextured.Format
            .DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, v)
        End With

        ' -------------------------------- Ripristino le matrici normali del device
        'DX_SetDeviceTransforms()


    End Sub






    ' ===============================================================================================
    '   DEFAULT RENDER PARAMS
    ' ===============================================================================================

    Private Sub SetDefaultRenderParams()

        ' -------------------------------------------------- 20 usec
        With DX_Device
            .Transform.View = mtx_CameraView
            .Transform.Projection = mtx_CameraProj

            .RenderState.AmbientColor = 0 ' &HFF808080


            .RenderState.ZBufferEnable = True
            .RenderState.ZBufferWriteEnable = True

            .RenderState.ZBufferFunction = Compare.LessEqual
            .RenderState.DepthBias = 0
            .RenderState.SlopeScaleDepthBias = 0

            .RenderState.Lighting = True
            .RenderState.SpecularEnable = True
            .RenderState.LocalViewer = True

            .RenderState.ShadeMode = ShadeMode.Gouraud

            If DEBUG_DrawWireFrame Then
                .RenderState.FillMode = FillMode.WireFrame
            Else
                .RenderState.FillMode = FillMode.Solid
            End If

            .RenderState.CullMode = Cull.CounterClockwise
            .RenderState.ZBufferWriteEnable = True
            .RenderState.NormalizeNormals = True
            .RenderState.DitherEnable = False

            .RenderState.AlphaBlendEnable = False

            .SamplerState(0).MagFilter = TextureFilter.Anisotropic
            .SamplerState(0).MinFilter = TextureFilter.Anisotropic
            .SamplerState(0).MipFilter = TextureFilter.Linear
            .SamplerState(0).MipMapLevelOfDetailBias = 0
            .SamplerState(0).MaxMipLevel = 0
            .SamplerState(0).MaxAnisotropy = 3

            .SamplerState(1).MagFilter = TextureFilter.Anisotropic
            .SamplerState(1).MinFilter = TextureFilter.Anisotropic
            .SamplerState(1).MipFilter = TextureFilter.Linear
            .SamplerState(1).MipMapLevelOfDetailBias = 0
            .SamplerState(1).MaxMipLevel = 0
            .SamplerState(1).MaxAnisotropy = 3


            .TextureState(0).ColorOperation = TextureOperation.Modulate
            .TextureState(0).ColorArgument1 = TextureArgument.TextureColor
            .TextureState(0).ColorArgument2 = TextureArgument.Current
            .TextureState(0).AlphaOperation = TextureOperation.SelectArg1
            .TextureState(0).AlphaArgument1 = TextureArgument.TextureColor
            .TextureState(0).ResultArgument = TextureArgument.Current

            .TextureState(0).TextureCoordinateIndex = 0
            .TextureState(0).TextureTransform = TextureTransform.Disable

            .SamplerState(0).AddressU = TextureAddress.Wrap
            .SamplerState(0).AddressV = TextureAddress.Wrap
            .SamplerState(0).AddressW = TextureAddress.Wrap

            .SamplerState(1).AddressU = TextureAddress.Wrap
            .SamplerState(1).AddressV = TextureAddress.Wrap
            .SamplerState(1).AddressW = TextureAddress.Wrap

            .TextureState(1).ColorOperation = TextureOperation.Disable
        End With

    End Sub






    ' ===============================================================================================
    '   DRAW
    ' ===============================================================================================

    Private Sub DrawTerrains(ByVal Obj As Object_3D)
        Dim m As Matrix = Matrix.Identity
        With DX_Device
            ' -------------------------------------------------------------------
            .SetTexture(0, Tex.Island)
            .TextureState(0).ColorOperation = TextureOperation.Modulate2X
            .TextureState(0).ColorArgument1 = TextureArgument.TextureColor
            .TextureState(0).ColorArgument2 = TextureArgument.Current
            .TextureState(0).TextureCoordinateIndex = 0

            ' ------------------------------------------------------------------- using also texture layer "1"
            If DEBUG_HiQuality Then
                m.M11 = 500
                m.M22 = 500
                .SetTransform(TransformType.Texture1, m)
                .TextureState(1).TextureTransform = TextureTransform.Count2
                .SetTexture(1, Tex.grassdark)
                .TextureState(1).ColorOperation = TextureOperation.Modulate2X
                .TextureState(1).ColorArgument1 = TextureArgument.TextureColor
                .TextureState(1).ColorArgument2 = TextureArgument.Current
                '.TextureState(1).AlphaOperation = TextureOperation.SelectArg1
                '.TextureState(1).AlphaArgument1 = TextureArgument.TextureColor
                .TextureState(1).ResultArgument = TextureArgument.Current
                .TextureState(1).TextureCoordinateIndex = 0

                .TextureState(2).ColorOperation = TextureOperation.Disable
            End If

            ' ------------------------------------------------------------------- TERRAIN FLAT
            If Obj.DrawType = DrawTypes.TERRAIN_FLAT Then
                .Material = Materials(1)
                Obj.MeshX.msh.DrawSubset(0)
                Obj.MeshX.msh.DrawSubset(2)
                Obj.MeshX.msh.DrawSubset(3)
            End If

            ' ------------------------------------------------------------------- TERRAIN MESH
            If Obj.DrawType = DrawTypes.TERRAIN_MESH Then
                .Material = Materials(7)
                .SetTexture(0, Tex.grassdark)
                m.M11 = 60
                m.M22 = 60
                .SetTransform(TransformType.Texture1, m)
                Obj.MeshX.msh.DrawSubset(0)
            End If

            ' ------------------------------------------------------------------- disable second layer
            .TextureState(1).TextureTransform = TextureTransform.Disable
            .TextureState(1).ColorOperation = TextureOperation.Disable
            .TextureState(0).ColorOperation = TextureOperation.Modulate
        End With
    End Sub




    Private Sub DrawCar(ByVal obj As Object_3D)

        With DX_Device

            Dim m As Mesh = obj.MeshX.msh
            For s As Int32 = 0 To ExMeshes.CarBody.mat.Length - 1
                .RenderState.CullMode = Cull.CounterClockwise
                .SetTexture(0, Tex.DefaultGrey)
                .RenderState.AlphaBlendEnable = False

                Select Case s
                    ' -------------------------------------------------------------- BODY
                    Case 0
                        DX_Device.Material = Material(0.4, 0.4, 0.4, 0.4, 0.4, 0.4, , , , , 0.2, 0.2, 0.2, 17)

                        .SetTexture(0, obj.Texture)
                        Dim mx As Matrix = Matrix.Identity
                        mx.M11 = 0.05
                        mx.M22 = 0.05
                        .SetTransform(TransformType.Texture0, mx)
                        .TextureState(0).TextureTransform = TextureTransform.Count2
                        .TextureState(0).TextureCoordinateIndex = TextureCoordinateIndex.CameraSpaceReflectionVector

                        ' ----------------------------------------------------------- PNEUS and BLACK PARTS
                    Case 3
                        DX_Device.Material = Material(0.1, 0.1, 0.1, 0.2, 0.2, 0.2, , , , , 0.05, 0.05, 0.0, 17)
                        .RenderState.CullMode = Cull.None

                        ' ----------------------------------------------------------- GLASS
                    Case 13
                        DX_Device.Material = Material(0.2, 0.2, 0.2, 0.3, 0.3, 0.3, 0.6, , , , 10.0, 10.0, 15.0, 30)

                        .RenderState.Lighting = True
                        .RenderState.SpecularEnable = True
                        .RenderState.LocalViewer = True
                        .RenderState.NormalizeNormals = True

                        '.RenderState.TextureFactor = &HA0000000

                        .RenderState.AlphaBlendEnable = True
                        .RenderState.BlendOperation = BlendOperation.Add
                        .RenderState.SourceBlend = Blend.SourceAlpha
                        .RenderState.DestinationBlend = Blend.InvSourceAlpha

                        '.RenderState.BlendFactor = Color.FromArgb(60, 0, 0, 0)
                        '.RenderState.AlphaBlendOperation = BlendOperation.Add
                        '.RenderState.AlphaSourceBlend = Blend.SourceAlpha
                        '.RenderState.AlphaDestinationBlend = Blend.InvSourceAlpha

                        .SetTexture(0, Tex.DefaultGrey)

                        '.TextureState(0).ColorOperation = TextureOperation.Modulate
                        '.TextureState(0).ColorArgument1 = TextureArgument.TextureColor
                        '.TextureState(0).ColorArgument2 = TextureArgument.Current

                        .TextureState(0).AlphaOperation = TextureOperation.SelectArg1
                        .TextureState(0).AlphaArgument1 = TextureArgument.Diffuse

                        .TextureState(1).ColorOperation = TextureOperation.Disable
                        .TextureState(1).AlphaOperation = TextureOperation.Disable

                        'Case 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14

                    Case Else                            ' predellini / specchietti / targa etc..
                        .Material = ExMeshes.CarBody.mat(s).Material3D

                End Select

                m.DrawSubset(s)

                ' ---------------------------------------------------------------------- disable TextureTransform
                .TextureState(0).TextureTransform = TextureTransform.Disable
                .TextureState(0).TextureCoordinateIndex = 0
            Next

            ' -------------------------------------------------------------------------- restore normal cull mode
            .RenderState.CullMode = Cull.CounterClockwise


            ' -------------------------------------------------------------------------- draw wheels
            Dim mtx As Matrix
            For i As Int32 = 0 To 3
                mtx = Matrix.Scaling(2, 1, 2) * obj.WheelMatrix(i)
                'mtx = obj.WheelMatrix(i)
                'mtx = obj.WheelMatrix(i) * Matrix.Translation(0, -0.1, 0)
                If i = 1 Or i = 3 Then
                    mtx = Matrix.RotationY(Math.PI) * mtx
                End If
                mtx_World = mtx
                .Transform.World = mtx_World
                Effects_UpdateMatrices()

                For s As Int32 = 0 To ExMeshes.CarWheel.mat.Length - 1
                    Select Case ExMeshes.CarWheel.mat(s).TextureFilename
                        Case "CAR3_RAD.JPG"
                            .SetTexture(0, Tex.ground)
                            .Material = Materials(11)
                            ExMeshes.CarWheel.msh.DrawSubset(s)

                        Case "CAR3_CHROME1", "CAR3_SIDE.JP"
                            .RenderState.CullMode = Cull.None
                            'Case Else
                            .SetTexture(0, Tex.DefaultGrey)
                            '.SetTexture(0, Tex.plateox2)
                            .Material = ExMeshes.CarWheel.mat(s).Material3D
                            ExMeshes.CarWheel.msh.DrawSubset(s)
                    End Select
                Next
            Next


            .Material = Materials(11)
        End With
    End Sub


    Private Sub DrawSoftObject(ByVal obj As Object_3D)
        With DX_Device
            ' --------------------------------------------------------------------------
            .RenderState.CullMode = Cull.None
            ' --------------------------------------------------------------------------
            mtx_World = obj.MeshX.mtx
            .Transform.World = mtx_World
            DX_Device.Material = Materials(8)
            DX_Device.SetTexture(0, obj.Texture)
            obj.MeshX.msh.DrawSubset(0)
            ' ------------------------------------------------------- restore normal cull mode
            .RenderState.CullMode = Cull.CounterClockwise
        End With
    End Sub


    Private Sub DrawCloth(ByVal obj As Object_3D)
        With DX_Device
            ' --------------------------------------------------------------------------
            .RenderState.CullMode = Cull.None
            ' --------------------------------------------------------------------------
            mtx_World = Matrix.Identity
            .Transform.World = mtx_World
            DX_Device.Material = Materials(8)
            DX_Device.SetTexture(0, obj.Texture)
            obj.MeshX.msh.DrawSubset(0)
            ' ------------------------------------------------------- restore normal cull mode
            .RenderState.CullMode = Cull.CounterClockwise
        End With
    End Sub



    Private Sub DrawRope(ByVal obj As Object_3D)
        With DX_Device
            ' --------------------------------------------------------------------------
            .RenderState.CullMode = Cull.None
            ' --------------------------------------------------------------------------
            mtx_World = Matrix.Identity
            .Transform.World = mtx_World
            DX_Device.Material = Materials(8)
            DX_Device.SetTexture(0, obj.Texture)
            obj.MeshX.msh.DrawSubset(0)
            ' ------------------------------------------------------- restore normal cull mode
            .RenderState.CullMode = Cull.CounterClockwise
        End With
    End Sub







    ' ------------------------------------------------------------------- draw CASTLE
    Private Sub DrawCastle(ByVal Obj As Object_3D)
        With DX_Device

            For s As Int32 = 0 To Obj.MeshX.mat.Length - 1

                Select Case Obj.MeshX.mat(s).TextureFilename
                    Case "castle_gold.jpg"
                        .SetTexture(0, Tex.CastleGold)
                    Case "castle_tiles_1.jpg", "castle_tiles_2.jpg", "castle_tiles_3.jpg", "castle_tiles_4.jpg", "castle_tiles_5.jpg"
                        .SetTexture(0, Tex.CastleTiles)
                    Case Else
                        .SetTexture(0, Tex.CastleTerracottaMud)
                End Select

                .Material = Obj.MeshX.mat(s).Material3D

                If DEBUG_ShowMovements AndAlso Obj.IsActive Then ShowMovementsWithDifferentColor(.Material)

                Obj.MeshX.msh.DrawSubset(s)
            Next
        End With
    End Sub


    ' ------------------------------------------------------------------- draw EIFFEL
    Private Sub DrawEiffel(ByVal Obj As Object_3D)
        With DX_Device
            .SetTexture(0, Tex.DefaultGrey)

            .Material = Materials(12)

            .RenderState.CullMode = Cull.None

            For s As Int32 = 0 To Obj.MeshX.mat.Length - 1

                '.Material = Obj.MeshX.mat(s).Material3D

                Obj.MeshX.msh.DrawSubset(s)
            Next
        End With
    End Sub


 

    Private Sub DrawCastleTerrain(ByVal obj As Object_3D)
        With DX_Device
            .SamplerState(0).MaxAnisotropy = 1

            ' --------------------------------------------- tiles
            .Material = Materials(9)
            .SetTexture(0, Tex.CastleTerracotta)
            obj.MeshX.msh.DrawSubset(3)
            obj.MeshX.msh.DrawSubset(4)
            obj.MeshX.msh.DrawSubset(5)
            obj.MeshX.msh.DrawSubset(6)
            obj.MeshX.msh.DrawSubset(7)
            obj.MeshX.msh.DrawSubset(8)

            ' --------------------------------------------- terrain
            .Material = Materials(10)
            .SetTexture(0, Tex.CastleTerrain)
            obj.MeshX.msh.DrawSubset(9)
            obj.MeshX.msh.DrawSubset(10)


            ' --------------------------------------------- mountains
            '.Material = Materials(9)
            '.SetTexture(0, Tex.CastleMountains)
            obj.MeshX.msh.DrawSubset(0)
            obj.MeshX.msh.DrawSubset(1)
            obj.MeshX.msh.DrawSubset(2)

            'DrawAllSubsets(obj.MeshX.msh)
            'DrawAllSubsetsWithMaterials(obj.MeshX.msh, obj.MeshX.mat)
        End With
    End Sub



    Private Sub DrawFluidParticle(ByVal obj As Object_3D)

        With DX_Device

            Dim m As Mesh = obj.MeshX.msh

            .RenderState.CullMode = Cull.CounterClockwise
            .SetTexture(0, Tex.DefaultGrey)
            .RenderState.AlphaBlendEnable = False


            Dim mat As Material = New Material
            With mat
                .AmbientColor = New ColorValue(0.0, 0.0, 0.5, 0.0)
                .DiffuseColor = New ColorValue(0.0, 0.0, 0.0, 0.2)
                .SpecularColor = New ColorValue(0.3, 0.3, 0.3, 0.0)
                .EmissiveColor = New ColorValue(0.0, 0.0, 0.0, 0.0)
                .SpecularSharpness = 8
            End With
            DX_Device.Material = mat

            .RenderState.Lighting = True
            .RenderState.SpecularEnable = True
            .RenderState.LocalViewer = True
            .RenderState.NormalizeNormals = True

            '.RenderState.TextureFactor = &HA0000000

            .RenderState.AlphaBlendEnable = True
            .RenderState.BlendOperation = BlendOperation.Add
            .RenderState.SourceBlend = Blend.SourceAlpha
            .RenderState.DestinationBlend = Blend.InvSourceAlpha

            '.RenderState.BlendFactor = Color.FromArgb(10, 0, 0, 0)

            '.TextureState(0).ColorOperation = TextureOperation.Modulate
            '.TextureState(0).ColorArgument1 = TextureArgument.TextureColor
            '.TextureState(0).ColorArgument2 = TextureArgument.Current

            .TextureState(0).AlphaOperation = TextureOperation.SelectArg1
            .TextureState(0).AlphaArgument1 = TextureArgument.Diffuse

            .TextureState(1).ColorOperation = TextureOperation.Disable
            .TextureState(1).AlphaOperation = TextureOperation.Disable


            m.DrawSubset(0)

            ' ---------------------------------------------------------------------- disable TextureTransform
            .TextureState(0).TextureTransform = TextureTransform.Disable
            .TextureState(0).TextureCoordinateIndex = 0

            .RenderState.AlphaBlendEnable = False
        End With
    End Sub


    Private Sub DrawFluidContainer(ByVal obj As Object_3D)

        With DX_Device

            Dim m As Mesh = obj.MeshX.msh

            .RenderState.CullMode = Cull.CounterClockwise
            .SetTexture(0, Tex.DefaultGrey)
            .RenderState.AlphaBlendEnable = False


            Dim mat As Material = New Material
            With mat
                .AmbientColor = New ColorValue(0.2, 0.2, 0.2, 0.0)
                .DiffuseColor = New ColorValue(0.3, 0.3, 0.3, 0.4)
                .SpecularColor = New ColorValue(10.0, 10.0, 15.0, 0.0)
                .EmissiveColor = New ColorValue(0.0, 0.0, 0.0, 0.0)
                .SpecularSharpness = 30
            End With
            DX_Device.Material = mat

            .RenderState.Lighting = True
            .RenderState.SpecularEnable = True
            .RenderState.LocalViewer = True
            .RenderState.NormalizeNormals = True

            '.RenderState.TextureFactor = &HA0000000

            .RenderState.AlphaBlendEnable = True
            .RenderState.BlendOperation = BlendOperation.Add
            .RenderState.SourceBlend = Blend.SourceAlpha
            .RenderState.DestinationBlend = Blend.InvSourceAlpha

            '.RenderState.BlendFactor = Color.FromArgb(10, 0, 0, 0)

            '.TextureState(0).ColorOperation = TextureOperation.Modulate
            '.TextureState(0).ColorArgument1 = TextureArgument.TextureColor
            '.TextureState(0).ColorArgument2 = TextureArgument.Current

            .TextureState(0).AlphaOperation = TextureOperation.SelectArg1
            .TextureState(0).AlphaArgument1 = TextureArgument.Diffuse

            .TextureState(1).ColorOperation = TextureOperation.Disable
            .TextureState(1).AlphaOperation = TextureOperation.Disable


            m.DrawSubset(0)

            ' ---------------------------------------------------------------------- disable TextureTransform
            .TextureState(0).TextureTransform = TextureTransform.Disable
            .TextureState(0).TextureCoordinateIndex = 0

            .RenderState.AlphaBlendEnable = False

        End With
    End Sub

    ' ------------------------------------------------------------------- draw BUILDINGS
    Private Sub DrawStaticObject(ByVal Obj As Object_3D)
        With DX_Device

            .Material = Materials(0)

            '.SetTexture(0, Tex.redrust2)
            .SetTexture(0, Obj.Texture)
            '.RenderState.CullMode = Cull.None

            'DrawAllSubsets(Obj.MeshX.msh)
            Obj.MeshX.msh.DrawSubset(0)
        End With
    End Sub

    ' ------------------------------------------------------------------- draw CHROME
    Private Sub DrawChrome(ByVal Obj As Object_3D)
        With DX_Device

            .Material = Material(1, 1, 1, 1, 1, 1, , , , , 1.3, 1, 2, 15)
            DX_Device.SetTexture(0, Tex.Gold)

            .TextureState(0).TextureCoordinateIndex = TextureCoordinateIndex.CameraSpaceReflectionVector

            Dim mx As Matrix = Matrix.Identity
            mx.M11 = 0.4
            mx.M22 = 0.2
            mx.M41 = -0.5
            mx.M42 = 0.05
            .SetTransform(TransformType.Texture0, mx)
            .TextureState(0).TextureTransform = TextureTransform.Count2

            .SamplerState(0).BorderColorValue = &HFF404010
            .SamplerState(0).AddressU = TextureAddress.Clamp
            .SamplerState(0).AddressV = TextureAddress.Border

            Obj.MeshX.msh.DrawSubset(0)

            ' ---------------------------------------------------------------------- disable
            .SamplerState(0).AddressU = TextureAddress.Wrap
            .SamplerState(0).AddressV = TextureAddress.Wrap
            .TextureState(0).TextureTransform = TextureTransform.Disable
            .TextureState(0).TextureCoordinateIndex = 0

        End With
    End Sub



    ' ===============================================================================================
    '   DRAW GENERIC
    ' ===============================================================================================

    Private Sub DrawGenericObject(ByVal obj As Object_3D)
        With DX_Device
            For s As Int32 = 0 To obj.MeshX.mat.Length - 1
                .SetTexture(0, obj.Texture)
                .Material = obj.MeshX.mat(s).Material3D
                If DEBUG_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(.Material)
                obj.MeshX.msh.DrawSubset(s)
            Next
        End With
    End Sub


    Private Sub DrawAllSubsets(ByVal m As Mesh)
        For s As Int32 = 0 To m.NumberAttributes - 1
            m.DrawSubset(s)
        Next
    End Sub

    Private Sub ShowMovementsWithDifferentColor(ByRef mat As Material)
        Dim m As Material = mat
        m.EmissiveColor = New ColorValue(1.0, 0.0, 0.0)
        m.AmbientColor = New ColorValue(1.0, 0.0, 0.0)
        m.SpecularColor = New ColorValue(0.5, 0.0, 0.0)
        m.DiffuseColor = New ColorValue(mat.DiffuseColor.Red, mat.DiffuseColor.Green * 0.5F, mat.DiffuseColor.Blue * 0.5F)
        mat = m
    End Sub





    ' ===============================================================================================
    '   DRAW ALL OBJECTS
    ' ===============================================================================================

    Friend Enum DrawOptions
        All
        VisibleObjects
        ShadowCasters
        ShadowReceivers
        ShadowCastersAndReceivers
    End Enum

    Private Sub DrawAllObjects(ByVal options As DrawOptions)
        ' ------------------------------------------------------------------------------ for each object
        For i As Int32 = 0 To UBound(Objects_3D)
            With Objects_3D(i)

                If options = DrawOptions.VisibleObjects And Not .DrawAsVisible Then
                    Continue For
                End If

                If options = DrawOptions.ShadowCastersAndReceivers And Not .DrawAsShadowCaster And Not .DrawAsShadowReceiver Then
                    Continue For
                End If

                ' ---------------------------------------------------------------------- set obj position and rotation
                mtx_World = .MeshX.mtx
                DX_Device.Transform.World = mtx_World
                Effects_UpdateMatrices()
                DrawObject(Objects_3D(i))
            End With
        Next
    End Sub


    Private Sub DrawObject(ByVal obj As Object_3D)
        ' ---------------------------------------------------------------------- draw the object
        Select Case obj.DrawType

            Case DrawTypes.BOX
                If DEBUG_HiQuality Then
                    DX_Device.Material = Materials(2)
                    DX_Device.SetTexture(0, Tex.iron_flo)  ' iron_flo / oldmetal
                    obj.MeshX.msh.DrawSubset(0)

                    DX_Device.Material = Materials(3)
                    If DEBUG_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(DX_Device.Material)
                    DX_Device.SetTexture(0, Tex.OldWood)
                    obj.MeshX.msh.DrawSubset(1)
                Else
                    ' ---------------------------------- must use "Box" because lowquality is improperly 
                    '                                     used by shaders without changing the "obj.MeshX.msh" 
                    DX_Device.Material = Materials(6)
                    If DEBUG_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(DX_Device.Material)
                    DX_Device.SetTexture(0, Tex.iron_flo)
                    Meshes.Box.DrawSubset(0)

                    'DX_Device.Material = Materials(3)
                    'If DX_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(DX_Device.Material)
                    'DX_Device.SetTexture(0, Tex.ground)
                    'obj.MeshX.msh.DrawSubset(0)
                End If

            Case DrawTypes.BARREL
                If DEBUG_HiQuality Then
                    DX_Device.Material = Materials(4)
                    If DEBUG_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(DX_Device.Material)
                    DX_Device.SetTexture(0, Tex.plateox2)
                    obj.MeshX.msh.DrawSubset(0)
                    DX_Device.SetTexture(0, Tex.oldmetal)
                    obj.MeshX.msh.DrawSubset(1)
                Else
                    DX_Device.Material = Materials(4)
                    If DEBUG_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(DX_Device.Material)
                    DX_Device.SetTexture(0, Tex.plateox2)
                    obj.MeshX.msh.DrawSubset(0)
                End If

            Case DrawTypes.BALL
                DX_Device.Material = Materials(6)
                If DEBUG_ShowMovements AndAlso obj.IsActive Then ShowMovementsWithDifferentColor(DX_Device.Material)
                DX_Device.SetTexture(0, Tex.iron_flo)
                obj.MeshX.msh.DrawSubset(0)



            Case DrawTypes.CAR
                DrawCar(obj)

            Case DrawTypes.TERRAIN_FLAT, DrawTypes.TERRAIN_MESH
                DrawTerrains(obj)

            Case DrawTypes.TERRAIN_CASTLE
                DrawCastleTerrain(obj)

            Case DrawTypes.CASTLE
                DrawCastle(obj)

            Case DrawTypes.EIFFEL
                DrawEiffel(obj)

            Case DrawTypes.MILL
                DrawStaticObject(obj)

            Case DrawTypes.SOFT_OBJECT
                DrawSoftObject(obj)

            Case DrawTypes.CLOTH
                DrawCloth(obj)

            Case DrawTypes.ROPE
                DrawRope(obj)

            Case DrawTypes.CHROME
                DrawChrome(obj)

            Case DrawTypes.GENERIC
                DrawGenericObject(obj)

        End Select
    End Sub




    ' ===============================================================================================
    '   DRAW ALL
    ' ===============================================================================================


    Friend Sub DX_DrawAll()
        With DX_Device
            .Clear(ClearFlags.Target Or ClearFlags.ZBuffer, Color.FromArgb(50, 40, 160), 1, 0)
            .BeginScene()
            If DEBUG_HiQuality Then DX_RenderAmbientMap()


            '    Case ShadowModes.PHONG
            'Effect_Phong_StartPass()
            'SetDefaultRenderParams()
            'DrawAllObjects(DrawOptions.VisibleObjects)
            'Effect_Phong_EndPass()

            If DEBUG_DisableShadows Then
                SetDefaultRenderParams()
                DrawAllObjects(DrawOptions.All)
            Else
                SetDefaultRenderParams()
                Effect_SMAP_PrepareForRenderShadow()
                DrawAllObjects(DrawOptions.ShadowCasters)
                Effect_SMAP_EndRenderShadow()

                SetDefaultRenderParams()
                Effect_SMAP_PrepareForRenderScene()
                DrawAllObjects(DrawOptions.ShadowCastersAndReceivers)
                Effect_SMAP_EndRenderScene()

                If Not DEBUG_ViewFinalMap Then
                    SetDefaultRenderParams()
                    DrawAllObjects(DrawOptions.VisibleObjects)
                    Effect_SMAP_DisplayTraspMap()
                End If

                If DEBUG_ViewShadowMap Then
                    Effect_SMAP_DisplayShadowMap()
                End If
            End If


            .EndScene()

        End With

        If DX_Device.CheckCooperativeLevel() Then
            DX_Device.Present()
        Else
            DX_ResetDevice()
        End If

    End Sub


End Module
