﻿Imports VB = Microsoft.VisualBasic
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D


Module DirectX_FileLoad

    ' ##############################################################################################
    ' ########
    ' ########        X-File Template Identifiers 
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################

    Private TID_D3DRMHeader As Guid = New Guid("3d82ab43-62da-11cf-ab39-0020af71e433")
    Private TID_D3DRMMaterial As Guid = New Guid("3d82ab4d-62da-11cf-ab39-0020af71e433")

    Private TID_D3DRMFrame As Guid = New Guid("3D82AB46-62DA-11cf-AB39-0020AF71E433")
    Private TID_D3DRMMesh As Guid = New Guid("3D82AB44-62DA-11cf-AB39-0020AF71E433")
    Private TID_D3DRMFrameTransformMatrix As Guid = New Guid("F6F23F41-7686-11cf-8F52-0040333594A3")
    'Private TID_D3DRMMaterialSet As Guid = New Guid("")

    Private TID_D3DRMAnimationSet As Guid = New Guid("3D82AB50-62DA-11cf-AB39-0020AF71E433")

    Private TID_D3DRMAnimation As Guid = New Guid("3D82AB4F-62DA-11cf-AB39-0020AF71E433")
    Private TID_D3DRMAnimationOptions As Guid = New Guid("E2BF56C0-840F-11cf-8F52-0040333594A3")
    Private TID_D3DRMAnimationKey As Guid = New Guid("10DD46A8-775B-11cf-8F52-0040333594A3")


    Private Sub RegisterTemplates(ByVal xfm As XFileManager)

        Dim xf As XFileManager = New XFileManager

        ' ------------------------------  default templates
        xfm.RegisterDefaultTemplates()

        ' ------------------------------  additional templates
        Dim tString As String
        tString = "xof 0302txt 0032 " & "template VertexDuplicationIndices{<b8d65549-d7c9-4995-89cf-53a9a8b031e3>" & "DWORD nIndices;DWORD nOriginalVertices;array DWORD indices[nIndices];} "

        tString = tString & "template XSkinMeshHeader{<3cf169ce-ff7c-44ab-93c0-f78f62d172e2>" & "WORD nMaxSkinWeightsPerVertex;WORD nMaxSkinWeightsPerFace;WORD nBones;} "

        tString = tString & "template SkinWeights{<6f0d123b-bad2-4167-a0d0-80224f25fabb>" & "STRING transformNodeName;DWORD nWeights;array DWORD vertexIndices[nWeights];" & "array FLOAT weights[nWeights];Matrix4x4 matrixOffset;} "

        xfm.RegisterTemplates(System.Text.Encoding.ASCII.GetBytes(tString))
    End Sub


    ' ##############################################################################################
    ' ########
    ' ########        FRAME InitFromFile 
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################

    Private Activated As Boolean
    Private DrawType As DrawTypes
    Private ObjType As ObjTypes
    Private SoundType As SoundTypes


    Public Sub LoadMultimeshFile(ByRef strFile As String, _
                                 ByVal mtx As Matrix, _
                                 ByVal _Activated As Boolean, _
                                 ByVal _DrawType As DrawTypes, _
                                 ByVal _ObjType As ObjTypes, _
                                 ByVal _SoundType As SoundTypes)

        Activated = _Activated
        DrawType = _DrawType
        ObjType = _ObjType
        SoundType = _SoundType

        Dim X_file As XFile
        Dim ChildData As XFileData
        ' ---------------------------------------------------------------- create the X file object
        Dim xfm As XFileManager = New XFileManager()
        ' ---------------------------------------------------------------- register templates
        RegisterTemplates(xfm)
        ' ---------------------------------------------------------------- open the file
        Try
            X_file = xfm.FromFile(strFile)
        Catch
            Return
        End Try
        ' ---------------------------------------------------------------- inspect each top level object in the file
        For i As Int32 = 0 To Math.Min(900, X_file.NumberChildren - 1)
            ChildData = X_file.GetChild(i)
            'Debug.Print("FROMFILE " & ChildData.Name & " " & ChildData.Type.ToString)
            Select Case ChildData.Type
                Case TID_D3DRMFrame
                    LoadFrameFromXOF(ChildData, mtx)

                Case TID_D3DRMMesh
                    Mesh_InitFromXOF(ChildData, mtx)

                Case TID_D3DRMAnimationSet
                    '
                Case TID_D3DRMHeader
                    'TODO Parse Header data

                Case TID_D3DRMMaterial
                    'TODO Parse TopLevel Material Data

                Case Else
                    MsgBox("InitFromFile - Unknown identifier: """ & ChildData.Type.ToString & """", MsgBoxStyle.Information)
            End Select

            ChildData = Nothing
        Next

        X_file.Dispose()
        X_file = Nothing
    End Sub




    ' ##############################################################################################
    ' ########
    ' ########        FRAME InitFromXOF 
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################


    Friend Sub LoadFrameFromXOF(ByRef FileData As XFileData, ByVal mtx As Matrix)
        Dim ChildData As XFileData
        For i As Int32 = 0 To FileData.NumberChildren - 1
            ' -------------------------------------------- inspect each object in the file
            ChildData = FileData.GetChild(i)
            'Debug.Print("FROMXOF " & ChildData.Name & " " & ChildData.Type.ToString)
            '
            Select Case ChildData.Type
                Case TID_D3DRMFrame
                    LoadFrameFromXOF(ChildData, mtx)

                Case TID_D3DRMMesh
                    Mesh_InitFromXOF(ChildData, mtx)

                Case TID_D3DRMFrameTransformMatrix
                    Dim gs As GraphicsStream = ChildData.Lock()
                    mtx = CType(gs.Read(GetType(Matrix)), Matrix) * mtx
                    ChildData.Unlock()
            End Select
        Next
    End Sub




    ' ##############################################################################################
    ' ########
    ' ########        MESH InitFromXOF 
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################

    Public Sub Mesh_InitFromXOF(ByRef MeshData As XFileData, ByRef mtx As Matrix)

        Dim MeshX As ExtendedMeshStruct
        MeshX.mat = Nothing
        MeshX.msh = Mesh.FromX(MeshData, MeshFlags.Managed, DX_Device, MeshX.mat)
        CopyDiffuseToAmbient(MeshX.mat)
        MeshX.mtx = mtx
        'MeshX.tex = Nothing

        'CalcFaceNormals(msh)

        'Select Case CType(MeshX.msh.VertexFormat, Integer)
        '    Case 2                          ' <- solo teapot
        '    Case 258, 18, 82, 274, 338, 594 ' <- casi normali
        '    Case 280, 282                   ' <- SKIN          (non necessitano di essere salvate)
        '    Case 22, 24, 26                 ' <- SKIN BabySumo (non necessitano di essere salvate)
        '    Case Else
        '        'Debug_AddError("Unimplemented vertex format." & "  Mesh : " & ObjName & "  Format : " & FVFtoString(m_mesh.VertexFormat) & " - Some operations will not be possible on this mesh.  ")
        'End Select

        App_CreateGenericObject(MeshX, 10, DrawType, ObjType, SoundType, Activated)

        MeshX = Nothing
    End Sub





    ' ##############################################################################################
    ' ########
    ' ########        LoadMesh  /  LoadExtendedMesh
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################


    Friend Function LoadMesh(ByVal FileName As String, Optional ByVal OptimizeForSoftObj As Boolean = False) As Mesh
        LoadMesh = Mesh.FromFile(MediaPath & "xFiles\" & FileName, MeshFlags.Managed, DX_Device)

        'If OptimizeForSoftObj Then OptimizeForSoft(LoadMesh)
    End Function


    Private Sub OptimizeForSoft(ByRef m As Mesh)
        'Dim adj(3 * m.NumberFaces - 1) As Int32
        'm.GenerateAdjacency(0.01, adj)
        'm = Mesh.Clean(CleanType.BowTies, m, adj, adj)

        Dim adj(3 * m.NumberFaces - 1) As Int32
        m.GenerateAdjacency(0.1F, adj)
        m.OptimizeInPlace(MeshFlags.OptimizeAttributeSort, adj)
        'm.OptimizeInPlace(MeshFlags.OptimizeCompact Or MeshFlags.OptimizeIgnoreVerts Or MeshFlags.OptimizeAttributeSort, adj)
        m.OptimizeInPlace(MeshFlags.OptimizeStripeReorder, adj)

        m.OptimizeInPlace(MeshFlags.OptimizeAttributeSort Or MeshFlags.OptimizeStripeReorder, adj)


        'Dim numIndices As Int32
        'Dim ib As IndexBuffer = Nothing 'm.IndexBuffer
        'ib = Mesh.ConvertMeshSubsetToSingleStrip(m, 0, MeshFlags.SystemMemory, numIndices)

        'Dim ranks(0) As Int32
        'ranks(0) = numIndices
        'Dim ar As Array = ib.Lock(0, GetType(Int16), LockFlags.None, ranks)
        ''Dim ar As Array = ib.Lock(0, GetType(Short), LockFlags.None)

        'Dim indices(numIndices) As Int16
        'For i As Int32 = 0 To numIndices - 1
        '    indices(i) = CShort(ar.GetValue(i))
        'Next
        'ib.Unlock()
        'm.IndexBuffer.SetData(indices, 0, LockFlags.Discard)

    End Sub


    Friend Sub LoadExtendedMesh(ByRef exMesh As ExtendedMeshStruct, ByVal FileName As String, ByVal m As Matrix)
        exMesh.msh = Mesh.FromFile(MediaPath & "xFiles\" & FileName, MeshFlags.Managed, DX_Device, exMesh.mat)
        '
        CopyDiffuseToAmbient(exMesh.mat)
        '
        exMesh.mtx = m
    End Sub

    Private Sub CopyDiffuseToAmbient(ByRef mat() As ExtendedMaterial)
        Dim m As Material
        For i As Int32 = 0 To mat.Length - 1
            With mat(i)
                m.DiffuseColor = .Material3D.DiffuseColor
                m.AmbientColor = .Material3D.DiffuseColor
                m.EmissiveColor = .Material3D.EmissiveColor
                m.SpecularColor = .Material3D.SpecularColor
                m.SpecularSharpness = .Material3D.SpecularSharpness
                .Material3D = m
            End With
        Next
    End Sub

End Module
