﻿Public Class Form2

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        DisplayMainParams()
        DisplayShadowParams()
        DisplayDeviceParams()
        DisplayDebugParams()
        DisplaySceneParams()
    End Sub

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not Application_Closing Then
            Me.Hide()
            e.Cancel = True
        End If
    End Sub

    Private Sub Form2_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        Select e.KeyCode
            Case Keys.F1, Keys.H
                If Me.Visible Then Me.Hide()
            Case Keys.Escape
                If Me.Visible Then
                    Me.Close()
                Else
                    Form1.Focus()
                    Form1.Form1_KeyDown(sender, e)
                End If
            Case Else
                Form1.Form1_KeyDown(sender, e)
        End Select
    End Sub


    ' ========================================================================================================
    '  MAIN PARAMS
    ' ========================================================================================================

    Private Sub MainParams_ChangedValue(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_LightDirection.TextChanged, _
                                                                                                     txt_LightHeigth.TextChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        If txt_LightDirection.NumericValue > 180 Then txt_LightDirection.NumericValue -= 360
        If txt_LightDirection.NumericValue < -180 Then txt_LightDirection.NumericValue += 360
        SetMainParams()
        DX_SetLightDirection()
        ExecFromTimer()
    End Sub

    Private Sub SkyType_ChangedValue(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SkyType.TextChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        DX_SkyType = txt_SkyType.NumericValueInteger
        DX_LoadAmbientMap()
        Select Case DX_SkyType
            Case 0 : DX_LightHeight = 20
            Case 1 : DX_LightHeight = 60
        End Select
        DisplayMainParams()
        DX_SetLightDirection()
    End Sub


    Private Sub MainParams_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_LightDirection.LostFocus, _
                                                                                                  txt_LightHeigth.LostFocus, _
                                                                                                  txt_SkyType.LostFocus

        If Not EventsAreEnabled Or Application_Closing Then Return
        SetMainParams()
        Save_INI()
    End Sub

    Private Sub SetMainParams()
        DX_LightDirection = CSng(txt_LightDirection.NumericValue)
        DX_LightHeight = CSng(txt_LightHeigth.NumericValue)
        DX_SkyType = txt_SkyType.NumericValueInteger
    End Sub

    Private Sub DisplayMainParams()
        txt_LightDirection.NumericValue = DX_LightDirection
        txt_LightHeigth.NumericValue = DX_LightHeight
        txt_SkyType.NumericValue = DX_SkyType
    End Sub


    ' ========================================================================================================
    '  SHADOW PARAMS
    ' ========================================================================================================

    Private Sub cmb_ShadowMapSize_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Shadow_ShadowMapSize.SelectedIndexChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetShadowParams()
        Effects_Init()
    End Sub

    Private Sub cmb_FinalMapSize_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Shadow_FinalMapSize.SelectedIndexChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetShadowParams()
        Effects_Init()
    End Sub

    Private Sub chk_HiQualityFilters_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_HiQualityFilters.CheckedChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetShadowParams()
        Effects_Init()
    End Sub

    Private Sub ShadowParams_ChangedValue(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_Shadow_Bias.TextChanged, _
                                                                                                        txt_Shadow_BiasAutoRange.TextChanged, _
                                                                                                        txt_Shadow_MaxDistance.TextChanged, _
                                                                                                        txt_Shadow_Coef.TextChanged, _
                                                                                                        txt_Shadow_EpsilonW.TextChanged, _
                                                                                                        txt_Shadow_FilterGain.TextChanged, _
                                                                                                        txt_Shadow_FilterType.TextChanged, _
                                                                                                        txt_Shadow_Density.TextChanged, _
                                                                                                        chk_XpsmCorrectedRotation.CheckedChanged, _
                                                                                                        chk_ShadowAddSmooth.CheckedChanged, _
                                                                                                        chk_HiQualityFilters.CheckedChanged, _
                                                                                                        chk_HiQualityObjects.CheckedChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetShadowParams()
    End Sub

    Private Sub ShadowParams_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_Shadow_Bias.LostFocus, _
                                                                                                    txt_Shadow_BiasAutoRange.LostFocus, _
                                                                                                    txt_Shadow_MaxDistance.LostFocus, _
                                                                                                    txt_Shadow_Coef.LostFocus, _
                                                                                                    txt_Shadow_EpsilonW.LostFocus, _
                                                                                                    txt_Shadow_FilterGain.LostFocus, _
                                                                                                    txt_Shadow_FilterType.LostFocus, _
                                                                                                    txt_Shadow_Density.LostFocus, _
                                                                                                    cmb_Shadow_ShadowMapSize.LostFocus, _
                                                                                                    cmb_Shadow_FinalMapSize.LostFocus, _
                                                                                                    chk_XpsmCorrectedRotation.LostFocus, _
                                                                                                    chk_ShadowAddSmooth.LostFocus, _
                                                                                                    chk_HiQualityFilters.LostFocus, _
                                                                                                    chk_HiQualityObjects.LostFocus

        If Not EventsAreEnabled Or Application_Closing Then Return
        SetShadowParams()
        Save_INI()
    End Sub


    Private Sub btn_ShadowDefaultsWarping_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsWarping.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0
        SHAD_Coefficent = 0.5
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 2
        SHAD_FilterType = 6
        SHAD_ShadowDensity = 0.5
        SHAD_ShadowMapSize = 1024
        SHAD_FinalMapSize = 512
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = True
        SHAD_HiQualityFilters = True
        SHAD_HiQualityObjects = True
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsWarping2_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsWarping2.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0
        SHAD_Coefficent = 0.5
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 2
        SHAD_FilterType = 5
        SHAD_ShadowDensity = 0.5
        SHAD_ShadowMapSize = 1024
        SHAD_FinalMapSize = 512
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = True
        SHAD_HiQualityFilters = True
        SHAD_HiQualityObjects = True
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsWarping3_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsWarping3.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0
        SHAD_Coefficent = 0.5
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 1
        SHAD_FilterType = 6
        SHAD_ShadowDensity = 0.5
        SHAD_ShadowMapSize = 1024
        SHAD_FinalMapSize = 512
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = False
        SHAD_HiQualityFilters = True
        SHAD_HiQualityObjects = True
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsOriginalXPSM_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsOriginalXPSM.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = -0.2
        SHAD_Coefficent = 0.5
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 2
        SHAD_FilterType = 6
        SHAD_ShadowDensity = 0.5
        SHAD_ShadowMapSize = 1024
        SHAD_FinalMapSize = 512
        SHAD_XpsmCorrectedRotation = False
        SHAD_ShadowAddSmooth = True
        SHAD_HiQualityFilters = True
        SHAD_HiQualityObjects = True
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsOrtho_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsOrtho.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0.0
        SHAD_Coefficent = 0
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 2
        SHAD_FilterType = 6
        SHAD_ShadowDensity = 0.5
        SHAD_ShadowMapSize = 1024
        SHAD_FinalMapSize = 512
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = True
        SHAD_HiQualityFilters = True
        SHAD_HiQualityObjects = True
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsOrtho2_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsOrtho2.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0.0
        SHAD_Coefficent = 0
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 1.5
        SHAD_FilterType = 5
        SHAD_ShadowDensity = 0.5
        SHAD_ShadowMapSize = 1024
        SHAD_FinalMapSize = 512
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = False
        SHAD_HiQualityFilters = False
        SHAD_HiQualityObjects = True
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsFast_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsFast.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0.0
        SHAD_Coefficent = 0.08
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 2.5
        SHAD_FilterType = -1
        SHAD_ShadowDensity = 0.35
        SHAD_ShadowMapSize = 512
        SHAD_FinalMapSize = 256
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = True
        SHAD_HiQualityFilters = False
        SHAD_HiQualityObjects = False
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub btn_ShadowDefaultsFast2_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShadowDefaultsFast2.ClickButtonArea
        EventsAreEnabled = False
        SHAD_Bias = 0.01
        SHAD_BiasAutoRange = 0.0
        SHAD_Coefficent = 0.08
        SHAD_EpsilonW = 0.85
        SHAD_MaxDistance = 40
        SHAD_FilterGain = 1.5
        SHAD_FilterType = -3
        SHAD_ShadowDensity = 0.35
        SHAD_ShadowMapSize = 512
        SHAD_FinalMapSize = 256
        SHAD_XpsmCorrectedRotation = True
        SHAD_ShadowAddSmooth = False
        SHAD_HiQualityFilters = False
        SHAD_HiQualityObjects = False
        DisplayShadowParams()
        EventsAreEnabled = True
        Save_INI()
        Effects_Init()
    End Sub

    Private Sub SetShadowParams()
        SHAD_Bias = CSng(txt_Shadow_Bias.NumericValue)
        SHAD_BiasAutoRange = CSng(txt_Shadow_BiasAutoRange.NumericValue)
        SHAD_Coefficent = CSng(txt_Shadow_Coef.NumericValue)
        SHAD_EpsilonW = CSng(txt_Shadow_EpsilonW.NumericValue)
        '
        SHAD_MaxDistance = CSng(txt_Shadow_MaxDistance.NumericValue)
        SHAD_FilterGain = CSng(txt_Shadow_FilterGain.NumericValue)
        SHAD_FilterType = txt_Shadow_FilterType.NumericValueInteger
        SHAD_ShadowDensity = CSng(txt_Shadow_Density.NumericValue)
        SHAD_ShadowMapSize = CInt(Val(cmb_Shadow_ShadowMapSize.Text))
        SHAD_FinalMapSize = CInt(Val(cmb_Shadow_FinalMapSize.Text))
        '
        SHAD_XpsmCorrectedRotation = chk_XpsmCorrectedRotation.Checked
        SHAD_ShadowAddSmooth = chk_ShadowAddSmooth.Checked
        SHAD_HiQualityFilters = chk_HiQualityFilters.Checked
        SHAD_HiQualityObjects = chk_HiQualityObjects.Checked
    End Sub

    Private Sub DisplayShadowParams()
        txt_Shadow_Bias.NumericValue = SHAD_Bias
        txt_Shadow_BiasAutoRange.NumericValue = SHAD_BiasAutoRange
        txt_Shadow_Coef.NumericValue = SHAD_Coefficent
        txt_Shadow_EpsilonW.NumericValue = SHAD_EpsilonW
        '
        txt_Shadow_MaxDistance.NumericValue = SHAD_MaxDistance
        txt_Shadow_FilterGain.NumericValue = SHAD_FilterGain
        txt_Shadow_FilterType.NumericValueInteger = SHAD_FilterType
        txt_Shadow_Density.NumericValue = SHAD_ShadowDensity
        Combo_SetIndex_FromString(cmb_Shadow_ShadowMapSize, SHAD_ShadowMapSize.ToString)
        Combo_SetIndex_FromString(cmb_Shadow_FinalMapSize, SHAD_FinalMapSize.ToString)
        '
        chk_XpsmCorrectedRotation.Checked = SHAD_XpsmCorrectedRotation
        chk_ShadowAddSmooth.Checked = SHAD_ShadowAddSmooth
        chk_HiQualityFilters.Checked = SHAD_HiQualityFilters
        chk_HiQualityObjects.Checked = SHAD_HiQualityObjects
    End Sub


    ' ========================================================================================================
    '  DEVICE PARAMS
    ' ========================================================================================================
    Private Sub DeviceParams_ChangedValue(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_BackBufferSize.SelectedIndexChanged, _
                                                                                                              cmb_Multisamples.SelectedIndexChanged, _
                                                                                                              chk_DeviceHardwareVertexProcessing.CheckedChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        chk_DeviceHardwareVertexProcessing.Refresh()
        SetDeviceParams()
        DX_ReinitDevice()
        DisplayDeviceParams()
        Save_INI()
    End Sub
    Private Sub SetDeviceParams()
        Select Case cmb_BackBufferSize.Text
            Case "512x384"
                DEVICE_BackBufferWidth = 512
                DEVICE_BackBufferHeight = 384
            Case "800x600"
                DEVICE_BackBufferWidth = 800
                DEVICE_BackBufferHeight = 600
            Case "1024x768"
                DEVICE_BackBufferWidth = 1024
                DEVICE_BackBufferHeight = 768
            Case "1280x1024"
                DEVICE_BackBufferWidth = 1280
                DEVICE_BackBufferHeight = 1024
            Case "1600x1200"
                DEVICE_BackBufferWidth = 1600
                DEVICE_BackBufferHeight = 1200
            Case Else
                DEVICE_BackBufferWidth = 0
                DEVICE_BackBufferHeight = 0
        End Select
        DEVICE_Multisamples = CInt(Val(cmb_Multisamples.Text))
        DEVICE_HardwareVertexProcessing = chk_DeviceHardwareVertexProcessing.Checked
    End Sub
    Private Sub DisplayDeviceParams()
        Dim s As String
        If DEVICE_BackBufferWidth = 0 Then
            s = "Screen size"
        Else
            s = DEVICE_BackBufferWidth.ToString & "x" & DEVICE_BackBufferHeight.ToString
        End If
        Combo_SetIndex_FromString(cmb_BackBufferSize, s)
        Combo_SetIndex_FromString(cmb_Multisamples, DEVICE_Multisamples.ToString)
        chk_DeviceHardwareVertexProcessing.Checked = DEVICE_HardwareVertexProcessing
    End Sub


    ' ========================================================================================================
    '  DEBUG PARAMS
    ' ========================================================================================================
    Private Sub Windowed_ChangedValue(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Windowed.CheckedChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetDebugParams()
        Form1.SetFullScreen()
    End Sub
    Private Sub DebugParams_ChangedValue(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ViewMainParams.CheckedChanged, _
                                                                                                      chk_ViewShadowMap.CheckedChanged, _
                                                                                                      chk_ViewFinalMap.CheckedChanged, _
                                                                                                      chk_DisableShadows.CheckedChanged, _
                                                                                                      chk_DisableSounds.CheckedChanged, _
                                                                                                      chk_LowQuality.CheckedChanged, _
                                                                                                      chk_Wireframe.CheckedChanged, _
                                                                                                      chk_Windowed.CheckedChanged, _
                                                                                                      chk_Multithreaded.CheckedChanged, _
                                                                                                      chk_ShowMovingObjects.CheckedChanged, _
                                                                                                      chk_ViewDebugParams.CheckedChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetDebugParams()
        Effects_Init()
    End Sub
    Private Sub DebugParams_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ViewMainParams.LostFocus, _
                                                                                                    chk_ViewShadowMap.LostFocus, _
                                                                                                    chk_ViewFinalMap.LostFocus, _
                                                                                                    chk_DisableShadows.LostFocus, _
                                                                                                    chk_DisableSounds.LostFocus, _
                                                                                                    chk_LowQuality.LostFocus, _
                                                                                                    chk_Wireframe.LostFocus, _
                                                                                                    chk_Windowed.LostFocus, _
                                                                                                    chk_Multithreaded.LostFocus, _
                                                                                                    chk_ShowMovingObjects.LostFocus, _
                                                                                                    chk_ViewDebugParams.LostFocus


        If Not EventsAreEnabled Or Application_Closing Then Return
        SetDebugParams()
        Save_INI()
    End Sub
    Private Sub SetDebugParams()
        DEBUG_ViewMainParams = chk_ViewMainParams.Checked
        DEBUG_ViewShadowMap = chk_ViewShadowMap.Checked
        DEBUG_ViewFinalMap = chk_ViewFinalMap.Checked
        DEBUG_DisableShadows = chk_DisableShadows.Checked
        DEBUG_DisableSounds = chk_DisableSounds.Checked
        DEBUG_HiQuality = Not chk_LowQuality.Checked
        DEBUG_DrawWireFrame = chk_Wireframe.Checked
        DEBUG_RunInWindow = chk_Windowed.Checked
        DEBUG_UseThreads = chk_Multithreaded.Checked
        DEBUG_ShowMovements = chk_ShowMovingObjects.Checked
        DEBUG_ViewDebugParams = chk_ViewDebugParams.Checked
        If Not DEBUG_ViewDebugParams Then
            Label_Debug1.Text = ""
            Label_Debug2.Text = ""
        End If
    End Sub
    Friend Sub DisplayDebugParams()
        chk_ViewMainParams.Checked = DEBUG_ViewMainParams
        chk_ViewShadowMap.Checked = DEBUG_ViewShadowMap
        chk_ViewFinalMap.Checked = DEBUG_ViewFinalMap
        chk_DisableShadows.Checked = DEBUG_DisableShadows
        chk_DisableSounds.Checked = DEBUG_DisableSounds
        chk_LowQuality.Checked = Not DEBUG_HiQuality
        chk_Wireframe.Checked = DEBUG_DrawWireFrame
        chk_Windowed.Checked = DEBUG_RunInWindow
        chk_Multithreaded.Checked = DEBUG_UseThreads
        chk_ShowMovingObjects.Checked = DEBUG_ShowMovements
        chk_ViewDebugParams.Checked = DEBUG_ViewDebugParams
    End Sub


    ' ========================================================================================================
    '  SCENE PARAMS
    ' ========================================================================================================
    Private Sub SceneParams_ChangedValue(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_SceneGroup.SelectedIndexChanged, _
                                                                                                       cmb_SceneNumber.SelectedIndexChanged
        If Not EventsAreEnabled Or Application_Closing Then Return
        chk_DeviceHardwareVertexProcessing.Refresh()
        SetSceneParams()
        App_StartScene()
    End Sub
    Private Sub SceneParams_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_SceneGroup.LostFocus, _
                                                                                                           cmb_SceneNumber.LostFocus
        If Not EventsAreEnabled Or Application_Closing Then Return
        chk_DeviceHardwareVertexProcessing.Refresh()
        SetSceneParams()
        Save_INI()
    End Sub
    Friend Sub SetSceneParams()
        App_CurrentScene = cmb_SceneGroup.SelectedIndex * 10 + cmb_SceneNumber.SelectedIndex
    End Sub
    Friend Sub DisplaySceneParams()
        cmb_SceneGroup.SelectedIndex = App_CurrentScene \ 10
        cmb_SceneNumber.SelectedIndex = App_CurrentScene Mod 10
        lbl_SceneNum.Text = App_CurrentScene.ToString
    End Sub

    ' ========================================================================================================
    '  SLOTS
    ' ========================================================================================================
    Private Sub Slots_ChangedValue(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SlotDir.TextChanged, _
                                                                                                       txt_SlotUp.TextChanged, _
                                                                                                       txt_SlotLbutton.TextChanged, _
                                                                                                       txt_SlotRbutton.TextChanged

        If Not EventsAreEnabled Or Application_Closing Then Return
        SetSlots()
    End Sub
    Private Sub Slots_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SlotDir.LostFocus, _
                                                                                                    txt_SlotUp.LostFocus, _
                                                                                                    txt_SlotLbutton.LostFocus, _
                                                                                                    txt_SlotRbutton.LostFocus
        If Not EventsAreEnabled Or Application_Closing Then Return
        SetSlots()
        Save_INI()
    End Sub
    Friend Sub SetSlots()
        SlotDir = txt_SlotDir.NumericValueInteger
        SlotUp = txt_SlotUp.NumericValueInteger
        SlotLbutton = txt_SlotLbutton.NumericValueInteger
        SlotRbutton = txt_SlotRbutton.NumericValueInteger
    End Sub

End Class